/* This demo shows the use of menu's.

   Written by Mark Overmars

   Date: 1 Oct 1992
*/

#include <gl/gl.h>
#include "forms.h"

main()
{
  FL_FORM *form;
  FL_OBJECT *obj, *button, *menu[4], *box[4];
  int i, j;
  int col[4];

  fl_init();
  form = fl_bgn_form(FL_NO_BOX,440.0,380.0);
  obj = fl_add_box(FL_BORDER_BOX,0.0,0.0,440.0,380.0,"");
    fl_set_object_color(obj,12,47);
  menu[0] = obj = fl_add_menu(FL_PUSH_MENU,0.0,350.0,110.0,30.0,"Color 1");
  menu[1] = obj = fl_add_menu(FL_PUSH_MENU,110.0,350.0,110.0,30.0,"Color 2");
  menu[2] = obj = fl_add_menu(FL_TOUCH_MENU,220.0,350.0,110.0,30.0,"Color 3");
  menu[3] = obj = fl_add_menu(FL_TOUCH_MENU,330.0,350.0,110.0,30.0,"Color 4");
  box[0] = obj = fl_add_box(FL_SHADOW_BOX,20.0,70.0,70.0,230.0,"");
  box[1] = obj = fl_add_box(FL_SHADOW_BOX,130.0,70.0,70.0,230.0,"");
  box[2] = obj = fl_add_box(FL_SHADOW_BOX,240.0,70.0,70.0,230.0,"");
  box[3] = obj = fl_add_box(FL_SHADOW_BOX,350.0,70.0,70.0,230.0,"");
  button = obj = fl_add_button(FL_NORMAL_BUTTON,310.0,20.0,110.0,30.0,"Exit");
  fl_end_form();

  for (i=0; i<4; i++)
  {
    fl_show_menu_symbol(menu[i], 1);
    fl_set_menu(menu[i],"Red|Green|Yellow|Blue|Purple|Light Blue|White");
    col[i] = i+1;
    fl_set_object_color(box[i], col[i], 0);
    for (j=1; j<=4; j++) fl_set_menu_item_mode(menu[i], j, PUP_GREY | PUP_BOX);
    for (j=5; j<=7; j++) fl_set_menu_item_mode(menu[i], j, PUP_BOX);
    fl_set_menu_item_mode(menu[i], col[i], PUP_CHECK);
  }

  fl_set_menu_item_shortcut(menu[0], 1, "q");  
  fl_set_menu_item_shortcut(menu[0], 2, "w");  
  fl_set_menu_item_shortcut(menu[0], 3, "e");  
  fl_set_menu_item_shortcut(menu[0], 4, "r");  
  fl_set_menu_item_shortcut(menu[0], 5, "t");  
  fl_set_menu_item_shortcut(menu[0], 6, "y");  
  fl_set_menu_item_shortcut(menu[0], 7, "u");  
  fl_set_menu_item_shortcut(menu[1], 1, "^q");  
  fl_set_menu_item_shortcut(menu[1], 2, "^w");  
  fl_set_menu_item_shortcut(menu[1], 3, "^e");  
  fl_set_menu_item_shortcut(menu[1], 4, "^r");  
  fl_set_menu_item_shortcut(menu[1], 5, "^t");  
  fl_set_menu_item_shortcut(menu[1], 6, "^y");  
  fl_set_menu_item_shortcut(menu[1], 7, "^u");  
  fl_set_menu_item_shortcut(menu[2], 1, "#^q");  
  fl_set_menu_item_shortcut(menu[2], 2, "#^w");  
  fl_set_menu_item_shortcut(menu[2], 3, "#^e");  
  fl_set_menu_item_shortcut(menu[2], 4, "#^r");  
  fl_set_menu_item_shortcut(menu[2], 5, "#^t");  
  fl_set_menu_item_shortcut(menu[2], 6, "#^y");  
  fl_set_menu_item_shortcut(menu[2], 7, "#^u");  
  fl_set_menu_item_shortcut(menu[3], 1, "#q");  
  fl_set_menu_item_shortcut(menu[3], 2, "#w");  
  fl_set_menu_item_shortcut(menu[3], 3, "#e");  
  fl_set_menu_item_shortcut(menu[3], 4, "#r");  
  fl_set_menu_item_shortcut(menu[3], 5, "#t");  
  fl_set_menu_item_shortcut(menu[3], 6, "#y");  
  fl_set_menu_item_shortcut(menu[3], 7, "#u"); 
   
  fl_show_form(form,FL_PLACE_CENTER,FALSE,NULL);
  do
  {
    obj = fl_do_forms();
    for (i=0; i<4; i++)
      if (obj == menu[i] && fl_get_menu(menu[i]) != -1)
      {
        for (j=0; j<4; j++) fl_set_menu_item_mode(menu[j], col[i], PUP_BOX);
	col[i] = fl_get_menu(menu[i]);
        for (j=0; j<4; j++) fl_set_menu_item_mode(menu[j], col[i], PUP_GREY | PUP_BOX);
	fl_set_menu_item_mode(menu[i], col[i], PUP_CHECK);	
	fl_set_object_color(box[i], col[i], 0);
      }
  } while (obj != button);
  fl_hide_form(form);
}
